/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/04/30
* Description        : Main program body.
*******************************************************************************/

/*
 *@Note
  Uļϵͳ̣
  USBHDM(PA11)USBHDP(PA12)
  ʾ Uļϵͳ,ֽΪλдļļɾ޸ļ
  ԣ޸ļ
  עļϵͳ֧ FAT12/FAT16/FAT32

*/

#include "debug.h"
#include "string.h"
#include "CHRV3UFI.h"
/* Global define */

/* USART3 TX-->B.10  RX-->B.11 */
/* USART2 TX-->A.2   RX-->A.3  */
/* USART1 TX-->A.9   RX-->A.10 */
/* UD+               PA12      */
/* UD-               PA11      */
// DHT22             PA4
// BH1750
// SCL               PA0
// SDA               PA1
// BMP085
// SCL               PA6
// SDA               PA7

#define SCL_Set()      GPIO_WriteBit(GPIOA, GPIO_Pin_0, Bit_SET)
#define SCL_Clr()      GPIO_WriteBit(GPIOA, GPIO_Pin_0, Bit_RESET)

#define SDA_Set()      GPIO_WriteBit(GPIOA, GPIO_Pin_1, Bit_SET)
#define SDA_Clr()      GPIO_WriteBit(GPIOA, GPIO_Pin_1, Bit_RESET)

#define IIC_WRITE      0
#define IIC_READ       1
#define SlaveAddress   0x46

#define IIC_SDA_IN     GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1)
unsigned char  BUF[3];

//unsigned int sd;
int sdp;

u8 ckc[22]={30,30,30,30,30,30,30,30,30,30,30,30};

u8 shour=8,smin=30,ssec=0;

typedef struct
{
    vu8 hour;
    vu8 min;
    vu8 sec;

    vu16 w_year;
    vu8  w_month;
    vu8  w_date;
    vu8  week;
}_calendar_obj;

_calendar_obj calendar;

u8 const table_week[12]={0,3,3,6,1,4,6,2,5,0,3,5};
const u8 mon_table[12]={31,28,31,30,31,30,31,31,30,31,30,31};

typedef enum { FAILED = 0, PASSED = !FAILED} TestStatus;

#define TxSize   (size(TxBuffer))
#define size(a)   (sizeof(a) / sizeof(*(a)))

u8 TxBuffer[] = "Buffer Send from USART2 to USART3 by polling!";
u8 RxBuffer[TxSize]={0};
u8 TxCnt = 0, RxCnt = 0;
TestStatus TransferStatus = FAILED;

u8 RTC_Init(void);
u8 Is_Leap_Year(u16 year);
u8 RTC_Alarm_Set(u16 syear,u8 smon,u8 sday,u8 hour,u8 min,u8 sec);
u8 RTC_Get(void);
u8 RTC_Get_Week(u16 year,u8 month,u8 day);
u8 RTC_Set(u16 syear,u8 smon,u8 sday,u8 hour,u8 min,u8 sec);

#define DHT11_IO_IN()  {GPIOA->CFGLR&=0XFFF0FFFF;GPIOA->CFGLR|=8<<16;}
#define DHT11_IO_OUT() {GPIOA->CFGLR&=0XFFF0FFFF;GPIOA->CFGLR|=3<<16;}
//IO
#define DHT11_DQ_IN  GPIO_ReadInputDataBit(GPIOA,GPIO_Pin_4)//PA4    ݶ˿

//BMP085
//#define SCL PA6
//#define SDA PA7

#define SCL_H()            GPIO_WriteBit(GPIOA, GPIO_Pin_6, Bit_SET)
#define SCL_L()            GPIO_WriteBit(GPIOA, GPIO_Pin_6, Bit_RESET)

#define SDA_H()            GPIO_WriteBit(GPIOA, GPIO_Pin_7, Bit_SET)
#define SDA_L()            GPIO_WriteBit(GPIOA, GPIO_Pin_7, Bit_RESET)

#define IIC_SIN            GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_7)
#define IIC_INPUT_MODE()   {GPIOA->CFGLR&=0X0FFFFFFF;GPIOA->CFGLR|=8<<28;}
#define IIC_OUTPUT_MODE()  {GPIOA->CFGLR&=0X0FFFFFFF;GPIOA->CFGLR|=3<<28;}

#define BMP085_SlaveAddress   0xee    //IICеĴӵַ
#define OSS 0

short ac1;
short ac2;
short ac3;
unsigned short ac4;
unsigned short ac5;
unsigned short ac6;
short b1;
short b2;
short mb;
short mc;
short md;
long  temperature = 0;
long  pressure = 0;


/* Global Variable */
__attribute__ ((aligned(4))) UINT8  RxBuffer[MAX_PACKET_SIZE] ;      // IN, must even address
__attribute__ ((aligned(4))) UINT8  TxBuffer[MAX_PACKET_SIZE] ;      // OUT, must even address
__attribute__ ((aligned(4))) UINT8  Com_Buffer[128];

UINT8  buf[100];                                  //ȿԸӦԼָ

/* ״̬,ʾ벢ͣ */
void mStopIfError( UINT8 iError )
{
    if ( iError == ERR_SUCCESS )
    {
        return;    /* ɹ */
    }
    printf( "Error: %02x\r\n", (UINT16)iError );  /* ʾ */
    /* ,Ӧ÷ԼCHRV3DiskStatus״̬,CHRV3DiskReadyѯǰUǷ,UѶϿôµȴU̲ٲ,
         Ĵ:
         1һCHRV3DiskReady,ɹ,Open,Read/Write
         2CHRV3DiskReadyɹ,ôǿнͷʼ */
    while(1)
    {  }
}
/*******************************************************************************
* Function Name  : USBHD_ClockCmd
* Description    : Set USB clock.
* Input          : None
* Return         : None
*******************************************************************************/
void USBHD_ClockCmd(UINT32 RCC_USBCLKSource,FunctionalState NewState)
{
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, NewState);
    EXTEN->EXTEN_CTR |= EXTEN_USBHD_IO_EN;
    RCC_USBCLKConfig(RCC_USBCLKSource);             //USBclk=PLLclk/1.5=48Mhz
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_USBHD,NewState);
}

char Buffercmp(uint8_t* Buf1, uint8_t* Buf2, uint16_t BufLength)
{
  while(BufLength--)
  {
    if(*Buf1 != *Buf2)
    {
      return 0;
    }
    Buf1++;
    Buf2++;
  }
  return 1;
}
/* USART3 TX-->B.10  RX-->B.11 */
/* USART2 TX-->A.2   RX-->A.3 */
/* USART1 TX-->A.9   RX-->A.10 */
void USARTx_CFG(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;
    USART_InitTypeDef USART_InitStructure;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2|RCC_APB1Periph_USART3, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA |RCC_APB2Periph_GPIOB , ENABLE);

    /* USART2 TX-->A.2   RX-->A.3 */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    /* USART3 TX-->B.10  RX-->B.11 */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    USART_InitStructure.USART_BaudRate = 9600;  //115200
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;

    USART_Init(USART2, &USART_InitStructure);
    USART_Cmd(USART2, ENABLE);

    USART_Init(USART3, &USART_InitStructure);
    USART_Cmd(USART3, ENABLE);
}

void mp3(char n)
{
    uint8_t i;
    unsigned char cmd3[10] = {0X7E, 0xFF, 0x06, 0X03, 0x00, 0x00, 0x00, 0xFE, 0xF8, 0XEF}; //*play index
    cmd3[6]=n;
    cmd3[8]=0xF8-n;
    for(i=0;i<10;i++)
    {
        USART_SendData(USART3, cmd3[i]);
        while(USART_GetFlagStatus(USART3, USART_FLAG_TXE) == RESET);
    }
}

//74 33 2E 74 78 74 3D 22 32 30 32 31 2D 31 32 2D 31 30 22 ff ff ff // t8.txt="2021-12-10"
void tn(void)
{
    uint8_t i;
    u8 ckc[22]={30,30,30,30,30,30,30,30,30,30,30,30};
    ckc[0]='t';
    ckc[1]='8';
    ckc[2]='.';
    ckc[3]='t';
    ckc[4]='x';
    ckc[5]='t';
    ckc[6]='=';
    ckc[7]='"';
    ckc[8]='2';
    ckc[9]='0';
    ckc[10]='2';
    ckc[11]='1';
    ckc[12]='-';
    ckc[13]='1';
    ckc[14]='2';
    ckc[15]='-';
    ckc[16]='1';
    ckc[17]='0';
    ckc[18]='"';
    ckc[19]=0xff;
    ckc[20]=0xff;
    ckc[21]=0xff;
    for(i=0;i<22;i++)
    {
        USART_SendData(USART2, ckc[i]);
        while(USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET);
    }
}

void tt(void)
{
    uint8_t i;
    // t9.txt="08-30-01"
    u8 ckc[22]={30,30,30,30,30,30,30,30,30,30,30,30};
    ckc[0]='t';
    ckc[1]='9';
    ckc[2]='.';
    ckc[3]='t';
    ckc[4]='x';
    ckc[5]='t';
    ckc[6]='=';
    ckc[7]='"';
   //printf("%d:%d:%d\r\n",calendar.hour,calendar.min,calendar.sec );
    ckc[8]=calendar.hour/10+'0';
    ckc[9]=calendar.hour%10+'0';
    ckc[10]=':';
    ckc[11]=calendar.min/10+'0';
    ckc[12]=calendar.min%10+'0';
    ckc[13]=':';
    ckc[14]=calendar.sec/10+'0';
    ckc[15]=calendar.sec%10+'0';
    ckc[16]='"';
    ckc[17]=0xff;
    ckc[18]=0xff;
    ckc[19]=0xff;

    for(i=0;i<20;i++)
    {
        USART_SendData(USART2, ckc[i]);
        while(USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET);
    }
}

static void RTC_NVIC_Config(void)
{
    NVIC_InitTypeDef NVIC_InitStructure;
    NVIC_InitStructure.NVIC_IRQChannel = RTC_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
}


u8 RTC_Init(void)
{
        u8 temp=0;
        RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR | RCC_APB1Periph_BKP, ENABLE);
        PWR_BackupAccessCmd(ENABLE);

        BKP_DeInit();
        RCC_LSEConfig(RCC_LSE_ON);
        while (RCC_GetFlagStatus(RCC_FLAG_LSERDY) == RESET&&temp<250)
        {
            temp++;
            Delay_Ms(20);
        }
        if(temp>=255)return 1;
        RCC_RTCCLKConfig(RCC_RTCCLKSource_LSE);
        RCC_RTCCLKCmd(ENABLE);
        RTC_WaitForLastTask();
        RTC_WaitForSynchro();
        RTC_ITConfig(RTC_IT_SEC, ENABLE);
        RTC_WaitForLastTask();
        RTC_EnterConfigMode();
        RTC_SetPrescaler(32767);
        RTC_WaitForLastTask();
        //RTC_Set(2019,10,8,13,58,55);              /* Setup Time */
        RTC_Set(2021,12,10,shour,smin,ssec);
        RTC_ExitConfigMode();
        BKP_WriteBackupRegister(BKP_DR1, 0XA1A1);

        RTC_NVIC_Config();
        RTC_Get();
        return 0;
}

u8 Is_Leap_Year(u16 year)
{
    if(year%4==0)
    {
        if(year%100==0)
        {
            if(year%400==0)return 1;
            else return 0;
        }else return 1;
    }else return 0;
}

u8 RTC_Set(u16 syear,u8 smon,u8 sday,u8 hour,u8 min,u8 sec)
{
    u16 t;
    u32 seccount=0;
    if(syear<1970||syear>2099)return 1;
    for(t=1970;t<syear;t++)
    {
        if(Is_Leap_Year(t))seccount+=31622400;
        else seccount+=31536000;
    }
    smon-=1;
    for(t=0;t<smon;t++)
    {
        seccount+=(u32)mon_table[t]*86400;
        if(Is_Leap_Year(syear)&&t==1)seccount+=86400;
    }
    seccount+=(u32)(sday-1)*86400;
    seccount+=(u32)hour*3600;
    seccount+=(u32)min*60;
    seccount+=sec;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR | RCC_APB1Periph_BKP, ENABLE);
    PWR_BackupAccessCmd(ENABLE);
    RTC_SetCounter(seccount);
    RTC_WaitForLastTask();
    return 0;
}

u8 RTC_Alarm_Set(u16 syear,u8 smon,u8 sday,u8 hour,u8 min,u8 sec)
{
    u16 t;
    u32 seccount=0;
    if(syear<1970||syear>2099)return 1;
    for(t=1970;t<syear;t++)
    {
        if(Is_Leap_Year(t))seccount+=31622400;
        else seccount+=31536000;
    }
    smon-=1;
    for(t=0;t<smon;t++)
    {
        seccount+=(u32)mon_table[t]*86400;
        if(Is_Leap_Year(syear)&&t==1)seccount+=86400;
    }
    seccount+=(u32)(sday-1)*86400;
    seccount+=(u32)hour*3600;
    seccount+=(u32)min*60;
    seccount+=sec;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR | RCC_APB1Periph_BKP, ENABLE);
    PWR_BackupAccessCmd(ENABLE);
    RTC_SetAlarm(seccount);
    RTC_WaitForLastTask();

    return 0;
}

u8 RTC_Get(void)
{
    static u16 daycnt=0;
    u32 timecount=0;
    u32 temp=0;
    u16 temp1=0;
    timecount=RTC_GetCounter();
    temp=timecount/86400;
    if(daycnt!=temp)
    {
        daycnt=temp;
        temp1=1970;
        while(temp>=365)
        {
            if(Is_Leap_Year(temp1))
            {
                if(temp>=366)temp-=366;
                else {temp1++;break;}
            }
            else temp-=365;
            temp1++;
        }
        calendar.w_year=temp1;
        temp1=0;
        while(temp>=28)
        {
            if(Is_Leap_Year(calendar.w_year)&&temp1==1)
            {
                if(temp>=29)temp-=29;
                else break;
            }
            else
            {
                if(temp>=mon_table[temp1])temp-=mon_table[temp1];
                else break;
            }
            temp1++;
        }
        calendar.w_month=temp1+1;
        calendar.w_date=temp+1;
    }
    temp=timecount%86400;
    calendar.hour=temp/3600;
    calendar.min=(temp%3600)/60;
    calendar.sec=(temp%3600)%60;
    calendar.week=RTC_Get_Week(calendar.w_year,calendar.w_month,calendar.w_date);
    return 0;
}

u8 RTC_Get_Week(u16 year,u8 month,u8 day)
{
    u16 temp2;
    u8 yearH,yearL;

    yearH=year/100; yearL=year%100;
    if (yearH>19)yearL+=100;
    temp2=yearL+yearL/4;
    temp2=temp2%7;
    temp2=temp2+day+table_week[month-1];
    if (yearL%4==0&&month<3)temp2--;
    return(temp2%7);
}

void RTC_IRQHandler(void)
{
    if (RTC_GetITStatus(RTC_IT_SEC) != RESET)   /* Seconds interrupt */
    {
    RTC_Get();
    }
    if(RTC_GetITStatus(RTC_IT_ALR)!= RESET)     /* Alarm clock interrupt */
    {
        RTC_ClearITPendingBit(RTC_IT_ALR);
    RTC_Get();
    }

    RTC_ClearITPendingBit(RTC_IT_SEC|RTC_IT_OW);
    RTC_WaitForLastTask();
}

void DHT11_Rst(void)
{
    DHT11_IO_OUT();                      //SET OUTPUT
    GPIO_ResetBits(GPIOA,GPIO_Pin_4);   //DQ
    //GPIO_ResetBits(GPIOA,GPIO_Pin_15);
    Delay_Ms(20);                        //18ms
    GPIO_SetBits(GPIOA,GPIO_Pin_4);     //DQ=1
    Delay_Us(20);                        //20~40us
}

u8 DHT11_Check(void)
{
    u8 retry=0;
    DHT11_IO_IN();                 //SET INPUT
    while (DHT11_DQ_IN&&retry<100) //DHT1140~80us
    {
        retry++;
        Delay_Us(1);
    }
    if(retry>=100)
        return 1;
    else
        retry=0;
    while (!DHT11_DQ_IN&&retry<100)//DHT11ͺٴ40~80us
    {
        retry++;
        Delay_Us(1);
    };
    if(retry>=100)
        return 1;
    return 0;
}

u8 DHT11_Read_Bit(void)
{
    u8 retry=0;
    while(DHT11_DQ_IN&&retry<100) //ȴΪ͵ƽ
    {
        retry++;
        Delay_Us(1);
    }
    retry=0;
    while(!DHT11_DQ_IN&&retry<100)//ȴߵƽ
    {
        retry++;
        Delay_Us(1);
    }
    Delay_Us(40);                 //ȴ40us
    if(DHT11_DQ_IN)
        return 1;
    else
        return 0;
}

u8 DHT11_Read_Byte(void)
{
    u8 i,dat;
    dat=0;
    for (i=0;i<8;i++)
     {
        dat<<=1;
        dat|=DHT11_Read_Bit();
   }
    return dat;
}

u8 DHT11_Read_Data(u16 *temp,u16 *humi)
{
    u8 buf[5];
    u8 i;
    DHT11_Rst();
    if(DHT11_Check()==0)
    {
        for(i=0;i<5;i++)            //ȡ40λ
        {
            buf[i]=DHT11_Read_Byte();
        }
        if((buf[0]+buf[1]+buf[2]+buf[3])==buf[4])
        {
            *humi=(buf[0]*256+buf[1])/10;//ʾ¶
            *temp=(buf[2]*256+buf[3])/10;//ʾʪ
        }
    }
    else
        return 1;
    return 0;
}

u8 DHT11_Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure;

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);  //ʹPA˿ʱ

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;             //PA4˿
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;       //
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);                 //ʼIO
    GPIO_SetBits(GPIOA,GPIO_Pin_4);                        //PA4  
    DHT11_Rst();                                           //λDHT11
    return DHT11_Check();                                  //ȴDHT11ĻӦ
}

void IIC_INPUT_MODE_SET(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure;
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD;
    GPIO_InitStructure.GPIO_Speed =GPIO_Speed_50MHz ;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
}

void IIC_OUTPUT_MODE_SET(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure;
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed =GPIO_Speed_50MHz ;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
}

void BH1750_Start(void)
{
    IIC_OUTPUT_MODE_SET();
    SDA_Set();
    SCL_Set();
    Delay_Us(5);
    SDA_Clr();
    Delay_Us(5);
    SCL_Clr();
}

void BH1750_Stop(void)
{
    IIC_OUTPUT_MODE_SET();
    SDA_Clr();
    SCL_Set();
    Delay_Us(5);
    SDA_Set();
    Delay_Us(5);
}

void BH1750_SendACK(char ack)
{
    IIC_OUTPUT_MODE_SET();
    SCL_Clr();
    if(ack) SDA_Set();
    else SDA_Clr();
    Delay_Us(2);
    SCL_Set();
    Delay_Us(5);
    SCL_Clr();
}

char BH1750_RecvACK()
{
    int cnt=0;
    IIC_INPUT_MODE_SET();
    SDA_Set();
    Delay_Us(1);
    SCL_Set();
    Delay_Us(1);
    while(IIC_SDA_IN)
    {
        cnt++;
        Delay_Us(1);
        if(cnt>=250)
        {
            BH1750_Stop();
            return 1;
        }
    }
    SCL_Clr();
    return 0;
}

void BH1750_SendByte(char data)
{
    char i;
    IIC_OUTPUT_MODE_SET();
    SCL_Clr();
    Delay_Us(2);
    for (i=0;i<8;i++)
    {
        if(data&0x80) SDA_Set();
        else SDA_Clr();
        data <<= 1;
        SCL_Set();
        Delay_Us(2);
        SCL_Clr();
        Delay_Us(2);
    }
}

char BH1750_RecvByte()
{
    char i;
    char data = 0;
    IIC_INPUT_MODE_SET();
    for (i=0;i<8;i++)
    {
        SCL_Clr();
        Delay_Us(2);
        SCL_Set();
        data <<= 1;
        SCL_Set();
        if(IIC_SDA_IN) data|=0x01;
        Delay_Us(2);
    }
    SCL_Clr();
    return data;
}

void Single_Write_BH1750(char REG_Address)
{
    BH1750_Start();
    BH1750_SendByte(SlaveAddress);
    BH1750_RecvACK();
    BH1750_SendByte(REG_Address);
    BH1750_RecvACK();
    BH1750_Stop();
}

void Multiple_Read_BH1750()
{
    BH1750_Start();
    BH1750_SendByte(SlaveAddress+1);
    BH1750_RecvACK();
    BUF[0] = BH1750_RecvByte();
    BH1750_SendACK(0);
    BUF[1] = BH1750_RecvByte();
    BH1750_SendACK(1);
    BH1750_Stop();
    Delay_Ms(5);
}

void BH1750_Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure;
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
}

void Get_Sunlight_Value(void)
{
    int dis_data=0;
    float temp;
    //unsigned int sd;
    Single_Write_BH1750(0x01);
    Single_Write_BH1750(0x10);
    Delay_Ms(180);
    Multiple_Read_BH1750();
    dis_data=BUF[0];
    dis_data=(dis_data<<8)+BUF[1];
    temp=(float)dis_data/1.2;
    sdp=temp;
    //printf("light= %d lx \r\n",sdp);
    //if(temp>100000) sd=99999;
    //else  sd=temp;
    //OLED_ShowNum(0,2,sd,5,16);
}

void BMP085_Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure;
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6|GPIO_Pin_7;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    GPIO_SetBits(GPIOA,GPIO_Pin_1);
}

void BMP085_Start(void)
{
      IIC_OUTPUT_MODE();
      SDA_H();
      SCL_H();
      Delay_Us(5);
      SDA_L();
      Delay_Us(5);
      SCL_L();
}

/**************************************
ֹͣź  BMP085_Stop()
**************************************/
void BMP085_Stop(void)
{
      IIC_OUTPUT_MODE();
      SDA_L();             //
      SCL_L();
      Delay_Us(5);
      SCL_H();             //ʱ
      Delay_Us(5);
      Delay_Us(5);
}

char BMP085_Wait_Ack(void)
{
    u16 ucErrTime=0;
    IIC_INPUT_MODE();
    SDA_H();
    Delay_Us(1);
    SCL_H();
    Delay_Us(1);
    while(IIC_SIN)
    {
        ucErrTime++;
        if(ucErrTime>250)
        {
            BMP085_Stop();
            return 1;
        }
    }
    SCL_L();
    return 0;
}

void BMP085_Ack(void)
{
    SCL_L();
    IIC_OUTPUT_MODE();
    SDA_L();
    Delay_Us(2);
    SCL_H();
    Delay_Us(2);
    SCL_L();
}

void BMP085_NAck(void)
{
    SCL_L();
    IIC_OUTPUT_MODE();
    SDA_H();
    Delay_Us(2);
    SCL_H();
    Delay_Us(2);
    SCL_L();
}

void BMP085_Send_Byte(char txd)
{
    char t;
    IIC_OUTPUT_MODE();
    SCL_L();
    for(t=0;t<8;t++)
    {
        if((txd&0x80)>>7)
            SDA_H();
        else
            SDA_L();
        txd<<=1;
        Delay_Us(2);
        SCL_H();
        Delay_Us(2);
        SCL_L();
        Delay_Us(2);
    }
}

char BMP085_Read_Byte(unsigned char ack)
{
      unsigned char i,receive=0;

      IIC_INPUT_MODE();
      for(i=0;i<8;i++)
      {
        SCL_L();
        Delay_Us(2);
            SCL_H();
        receive<<=1;
        if(IIC_SIN) receive++;
        Delay_Us(1);
    }
    if(!ack)
        BMP085_NAck();
    else
        BMP085_Ack();
    return receive;
}

short Multiple_read(char ST_Address)
{
      char msb, lsb;
      short _data;
      BMP085_Start();
      BMP085_Send_Byte(BMP085_SlaveAddress);
      while(BMP085_Wait_Ack());
      BMP085_Send_Byte(ST_Address);
      while(BMP085_Wait_Ack());
      BMP085_Start();
      BMP085_Send_Byte(BMP085_SlaveAddress+1);
      while(BMP085_Wait_Ack());
      msb = BMP085_Read_Byte(1);
      lsb = BMP085_Read_Byte(0);
      BMP085_Stop();
      Delay_Ms(5);
      _data = msb << 8;
      _data |= lsb;
      return _data;
}

long bmp085ReadTemp(void)
{
    BMP085_Start();
    BMP085_Send_Byte(BMP085_SlaveAddress);
    while(BMP085_Wait_Ack());
    BMP085_Send_Byte(0xF4);
    while(BMP085_Wait_Ack());
    BMP085_Send_Byte(0x2E);
    while(BMP085_Wait_Ack());
    BMP085_Stop();
    Delay_Ms(10);
    return (long) Multiple_read(0xF6);
}

long bmp085ReadPressure(void)
{
    long pressure = 0;
    BMP085_Start();
    BMP085_Send_Byte(BMP085_SlaveAddress);
    while(BMP085_Wait_Ack()){}
    BMP085_Send_Byte(0xF4);
    while(BMP085_Wait_Ack()){}
    BMP085_Send_Byte(0x34);
    while(BMP085_Wait_Ack()){}
    BMP085_Stop();
    Delay_Ms(10);
    pressure = Multiple_read(0xF6);
    pressure &= 0x0000FFFF;
    return pressure;
}

void Init_BMP085()
{
    ac1 = Multiple_read(0xAA);
    ac2 = Multiple_read(0xAC);
    ac3 = Multiple_read(0xAE);
    ac4 = Multiple_read(0xB0);
    ac5 = Multiple_read(0xB2);
    ac6 = Multiple_read(0xB4);
    b1 =  Multiple_read(0xB6);
    b2 =  Multiple_read(0xB8);
    mb =  Multiple_read(0xBA);
    mc =  Multiple_read(0xBC);
    md =  Multiple_read(0xBE);
}

void bmp085Convert()
{
      unsigned int ut;
      unsigned long up;
      long x1, x2, b5, b6, x3, b3, p;
      unsigned long b4, b7;

      ut = bmp085ReadTemp();
      up = bmp085ReadPressure();
      x1 = (((long)ut - (long)ac6)*(long)ac5) >> 15;
      x2 = ((long) mc << 11) / (x1 + md);
      b5 = x1 + x2;
      temperature = ((b5 + 8) >> 4);
      temperature=temperature/10;
      b6 = b5 - 4000;
      x1 = (b2 * (b6 * b6)>>12)>>11;
      x2 = (ac2 * b6)>>11;
      x3 = x1 + x2;
      b3 = (((((long)ac1)*4 + x3)<<OSS) + 2)>>2;
      x1 = (ac3 * b6)>>13;
      x2 = (b1 * ((b6 * b6)>>12))>>16;
      x3 = ((x1 + x2) + 2)>>2;
      b4 = (ac4 * (unsigned long)(x3 + 32768))>>15;
      b7 = ((unsigned long)(up - b3) * (50000>>OSS));
      if (b7 < 0x80000000)
        p = (b7<<1)/b4;
      else
        p = (b7/b4)<<1;
      x1 = (p>>8) * (p>>8);
      x1 = (x1 * 3038)>>16;
      x2 = (-7357 * p)>>16;
      pressure = p+((x1 + x2 + 3791)>>4);
      pressure =pressure/100;
      if(pressure<1000) pressure=1016;
}

//cle 17,255
void tclr(void)
{
    uint8_t i;
    u8 cj[17]={30,30,30,30,30,30,30,30,30,30,30,30};
    cj[0]='c';
    cj[1]='l';
    cj[2]='e';
    cj[3]=' ';
    cj[4]='1';
    cj[5]='7';
    cj[6]=',';
    cj[7]='2';
    cj[8]='5';
    cj[9]='5';
    cj[10]=0xff;
    cj[11]=0xff;
    cj[12]=0xff;
    for(i=0;i<13;i++)
    {
        USART_SendData(USART2, cj[i]);
        while(USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET);
    }
}

void ta(void)
{
    uint8_t i;
    u8 cj[17]={30,30,30,30,30,30,30,30,30,30,30,30};
    cj[0]='t';
    cj[1]='5';
    cj[2]='.';
    cj[3]='t';
    cj[4]='x';
    cj[5]='t';
    cj[6]='=';
    cj[7]='"';
    cj[8]=(sdp%100000)/10000+'0';
    cj[9]=(sdp%10000)/1000+'0';
    cj[10]=(sdp%1000)/100+'0';
    cj[11]=(sdp%100)/10+'0';
    cj[12]=(sdp%10)+'0';
    cj[13]='"';
    cj[14]=0xff;
    cj[15]=0xff;
    cj[16]=0xff;
    for(i=0;i<17;i++)
    {
        USART_SendData(USART2, cj[i]);
        while(USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET);
    }
    //61 64 64 20 31 37 2C 32 2C 32 38 30 ff ff ff //  add 17,2,280
    cj[0]='a';
    cj[1]='d';
    cj[2]='d';
    cj[3]=' ';
    cj[4]='1';
    cj[5]='7';
    cj[6]=',';
    cj[7]='2';
    cj[8]=',';
    if(sdp>2550)
    {
        cj[9]='0';
        cj[10]='2';
        cj[11]='5';
        cj[12]='4';
    }
    else
    {
        cj[9]='0';
        cj[10]=(sdp%10000)/1000+'0';
        cj[11]=(sdp%1000)/100+'0';
        cj[12]=(sdp%100)/10+'0';
    }

    cj[13]=0xff;
    cj[14]=0xff;
    cj[15]=0xff;
    for(i=0;i<16;i++)
    {
        USART_SendData(USART2, cj[i]);
        while(USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET);
    }
}

void twsd(u16 tem1,u16 hum1)
{
    uint8_t i;
    u8 cj[16]={30};
    cj[0]='t';
    cj[1]='1';
    cj[2]='.';
    cj[3]='t';
    cj[4]='x';
    cj[5]='t';
    cj[6]='=';
    cj[7]='"';
    cj[8]=' ';
    //temp=temp_a;
    //temp=36;
    cj[9]=(tem1%100)/10+'0';
    cj[10]=(tem1%10)+'0';
    cj[11]='"';
    cj[12]=0xff;
    cj[13]=0xff;
    cj[14]=0xff;

    for(i=0;i<15;i++)
    {
        USART_SendData(USART2, cj[i]);
        while(USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET);
    }
    //temp=humi_a;
    //temp=40;
    cj[1]='3';
    cj[9]=(hum1%100)/10+'0';
    cj[10]=(hum1%10)+'0';
    for(i=0;i<15;i++)
    {
        USART_SendData(USART2, cj[i]);
        while(USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET);
    }

    cj[0]='a';
    cj[1]='d';
    cj[2]='d';
    cj[3]=' ';
    cj[4]='1';
    cj[5]='7';
    cj[6]=',';
    cj[7]='0';
    cj[8]=',';
    //temp=temp_a;
    //temp=36;
    cj[9]=(tem1%1000)/100+'0';
    cj[10]=(tem1%100)/10+'0';
    cj[11]=(tem1%10)+'0';

    cj[12]=0xff;
    cj[13]=0xff;
    cj[14]=0xff;
    for(i=0;i<15;i++)
    {
        USART_SendData(USART2, cj[i]);
        while(USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET);
    }

    cj[7]='1';
    //temp=humi_a;
    //temp=40;
    cj[9]=(hum1%1000)/100+'0';
    cj[10]=(hum1%100)/10+'0';
    cj[11]=(hum1% 10)+'0';
    for(i=0;i<15;i++)
    {
        USART_SendData(USART2, cj[i]);
        while(USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET);
    }
}

void ty(void)
{
    uint8_t i;
    uint16_t pres;
    u8 cj[16]={30,30,30,30,30,30,30,30,30,30,30,30};
    cj[0]='t';
    cj[1]='7';
    cj[2]='.';
    cj[3]='t';
    cj[4]='x';
    cj[5]='t';
    cj[6]='=';
    cj[7]='"';
    pres=pressure;
    //if(pres<1000) pres=1016;
    cj[8]=(pres%10000)/1000+'0';
    cj[9]=(pres%1000)/100+'0';
    cj[10]=(pres%100)/10+'0';
    cj[11]=pres%10+'0';
    cj[12]='"';
    cj[13]=0xff;
    cj[14]=0xff;
    cj[15]=0xff;
    for(i=0;i<16;i++)
    {
        USART_SendData(USART2, cj[i]);
        while(USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET);
    }
}

/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Return         : None
*******************************************************************************/
int main()
{
    UINT8 s,i;
    UINT16 TotalCount;
    UINT8 t,tp;
    u16 temperature1;
    u16 humidity;
    uint8_t F=0;
    uint8_t zl[] = "Q000000";

    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(9600);//115200

    //printf("SystemClk:%d\r\n",SystemCoreClock);
    //printf("USART Polling TEST\r\n");
    RTC_Init();
    BH1750_Init();
    DHT11_Init();
    BMP085_Init();
    Init_BMP085();

    USARTx_CFG();
    /* USART3 TX-->B.10  RX-->B.11 */
    Delay_Ms(500);
    mp3(0x18);
    Delay_Ms(5000);
    Delay_Ms(4000);
    //mp3(0x19);
    //Delay_Ms(7500);
    //mp3(0x1a);
    //Delay_Ms(5500);
    //tn();

    RxCnt=0;
    while(F==0)
    {
        //ָ
        RxCnt=0;
        // USART2 TX-->A.2   RX-->A.3
        while(RxCnt<7)  // JIESHOU OK
        {
            while(USART_GetFlagStatus(USART2, USART_FLAG_RXNE) == RESET);
            RxBuffer[RxCnt] = (USART_ReceiveData(USART2));
            RxCnt++;
        }

        // N211210 -- 4E 32 31 31 32 31 30
        // T083010 -- 54 30 38 33 30 31 30
        // ȡ ʱ

        if(RxBuffer[0]=='C')
        {
            mp3(0x11);
            Delay_Ms(2200);
        }

        if(RxBuffer[0]=='P')
        {
            mp3(0x12);
            Delay_Ms(2200);
        }

        if(RxBuffer[0]=='Z')
        {
            mp3(0x16);
            Delay_Ms(3500);

            mp3(0x17);
            Delay_Ms(2300);
        }

        if(RxBuffer[0]=='N')
        {
            mp3(0x13);
            Delay_Ms(1200);
        }

        if(RxBuffer[0]=='T')
        {
            mp3(0x14);
            Delay_Ms(1200);
        }

        if(RxBuffer[0]=='T')
        {
                //ȡ ʱ
                //  RTC_Set(2019,10,8,13,58,55);
                //4E 32 31 30 39 32 39    N210929
                //54 30 38 33 30 30 30 ʱ  T083000
                //calendar.w_year=2000+(RxBuffer[1]-0x30)*10+(RxBuffer[2]-0x30);
                //calendar.w_month=(RxBuffer[3]-0x30)*10+(RxBuffer[4]-0x30);
                //calendar.w_date=(RxBuffer[5]-0x30)*10+(RxBuffer[6]-0x30);
                //RTC_Set(2021,12,10,shour,smin,ssec);
                shour=(RxBuffer[1]-0x30)*10+(RxBuffer[2]-0x30);
                smin=(RxBuffer[3]-0x30)*10+(RxBuffer[4]-0x30);
                ssec=(RxBuffer[5]-0x30)*10+(RxBuffer[6]-0x30);
        }
        F=Buffercmp(zl,RxBuffer,7);

        //Delay_Ms(100);
    }

    if(RxBuffer[0]=='Q')
    {
        mp3(0x10);
        Delay_Ms(1200);
    }
    //goto hh;

    printf("USBHD HOST Test\r\n");
    USBHD_ClockCmd(RCC_USBCLKSource_PLLCLK_1Div5,ENABLE);
    pHOST_RX_RAM_Addr = RxBuffer;
    pHOST_TX_RAM_Addr = TxBuffer;
    USB_HostInit();
    CHRV3LibInit();
    printf( "Wait Device In\r\n" );

    while(1)
    {
        s = ERR_SUCCESS;

        if( R8_USB_INT_FG & RB_UIF_DETECT )
        {
            R8_USB_INT_FG = RB_UIF_DETECT ;

            s = AnalyzeRootHub( );
            if ( s == ERR_USB_CONNECT )
            {
                printf( "New Device In\r\n" );
                FoundNewDev = 1;
            }
            if( s == ERR_USB_DISCON )
            {
                printf( "Device Out\r\n" );
            }
        }

        if( FoundNewDev || s == ERR_USB_CONNECT )
        { ///
            FoundNewDev = 0;
            Delay_Ms( 200 );
            s = InitRootDevice( Com_Buffer );
            if ( s == ERR_SUCCESS )
            {
                // U̲̣USB߸λUӡȡ豸USBַѡĻȡ֮󵽴˴CH103ӳɺ
                CHRV3DiskStatus = DISK_USB_ADDR;
                for ( i = 0; i != 10; i ++ )
                {
                    printf( "Wait DiskReady\r\n" );
                    s = CHRV3DiskReady( );                                 //ȴU׼
                    if ( s == ERR_SUCCESS )
                    {
                        break;
                    }
                    else
                    {
                        printf("%02x\r\n",(UINT16)s);
                    }
                    Delay_Ms( 50 );
                }

                if( CHRV3DiskStatus >= DISK_MOUNTED )
                {
                    ////
                        //ļʾ
                        printf( "Find No File And Create\r\n" );
                        strcpy( (PCHAR)mCmdParam.Create.mPathName, "/NEWFILE.TXT" );   /* ļ,ڸĿ¼,ļ */
                        s = CHRV3FileCreate( );                                        /* ½ļ,ļѾɾ½ */
                        mStopIfError( s );
                        printf( "ByteWrite\n" );
                        //ʵӦждݳȺͶ建ǷڻҪд
                        RTC_Get();
                        t=calendar.sec;
                        tp=t;
                }
            }
        }///

        //Delay_Ms( 100 );   // ģⵥƬ
        //SetUsbSpeed( 1 );  // ĬΪȫ
        //hh:
        Delay_Ms(100);
        TotalCount=0;
        DHT11_Read_Data(&temperature1,&humidity);
        bmp085Convert();

        RTC_Get();
        t=calendar.sec;
        tp=t;
        while(1)
        {
            //RTC_Get();
            //t=calendar.sec;

            if(t==(tp+1))
            {
                Get_Sunlight_Value();
                //bmp085Convert();
                //printf("%d-%d-%d\r\n",calendar.w_year,calendar.w_month,calendar.w_date);
                printf("%d:%d:%d\r\n",calendar.hour,calendar.min,calendar.sec );
                printf("Temp=%d C \r\n",temperature1);        //ʾ¶
                printf("Humi=%d %%\r\n",humidity);        //ʾʪ
                printf("Temp=%d C \r\n",(temperature/10));     //ʾ¶
                printf("pres=%d KP\r\n",(pressure));       //ʾʪ
                printf("light=%d lx\r\n",sdp);
                tt();    //time
                ta();    //lx
                twsd(temperature1,humidity);  //c %
                ty();    //kp

                //JL
                i = sprintf( (PCHAR)buf,"%d:%d:%d %dlx %dC% d%% %dkp\r\n",calendar.hour,calendar.min,calendar.sec,sdp,temperature1,humidity,pressure);
                mCmdParam.ByteWrite.mByteCount = i;            //ָдֽ
                mCmdParam.ByteWrite.mByteBuffer = buf;         //ָ򻺳
                s = CHRV3ByteWrite( );                         // ֽΪλļд
                mStopIfError( s );
                printf("ɹд %04X\r\n",(UINT16) TotalCount);

                tp=t;
                TotalCount++;
                if(TotalCount==720)
                {
                    tclr();
                    TotalCount=0;
                }
            }
            else {
                RTC_Get();
                t=calendar.sec;
                //tt();    //time
                DHT11_Read_Data(&temperature1,&humidity);
                bmp085Convert();

                if(USART_GetFlagStatus(USART2, USART_FLAG_RXNE)== SET)
                {
                    if(USART_ReceiveData(USART2)=='Z')
                    {
                        printf("Close\r\n");
                        mCmdParam.Close.mUpdateLen = 1;             /* Զļ,ֽΪλдļ,óرļԱԶļ */
                        i = CHRV3FileClose( );
                        mStopIfError( i );

                        mp3(0x16);
                        Delay_Ms(4000);

                        mp3(0x17);
                        Delay_Ms(2300);
                    }
                    while(1);
                }
                Delay_Ms(100);
            }
        }
    }
}


